=== debian/changelog ===
vulkan-validationlayers (1.2.131.2-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump build-deps on libvulkan-dev, spirv-tools.
  * control: Migrate to debhelper-compat, bump to 12.
  * control: Bump policy to 4.5, no changes.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 12 Feb 2020 11:56:15 +0200
