=== debian/changelog ===
vulkan-validationlayers (1.2.141.0-1) unstable; urgency=medium

  * New upstream release. (Closes: #963289)
  * control: Add spirv-headers to build-depends.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 23 Jun 2020 11:25:16 +0300

vulkan-validationlayers (1.2.135.0-1) unstable; urgency=medium

  * New upstream release. (LP: #1871754)
  * control: Bump build-dep on glslang, libvulkan-dev and spirv-tools.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 10 Apr 2020 07:22:19 +0300
