=== debian/control ===
--- 
+++ 
@@ -4,14 +4,15 @@
 Uploaders: Timo Aaltonen <tjaalton@debian.org>
 Build-Depends: debhelper-compat (= 12),
  cmake,
- glslang-dev (>= 7.12.3352),
- libvulkan-dev (>= 1.2.131.2),
+ glslang-dev (>= 8.13.3559+git3727),
+ libvulkan-dev (>= 1.2.135.0),
  libwayland-dev,
  libx11-dev,
  libxrandr-dev,
  pkg-config,
  python3,
- spirv-tools (>= 2020.1),
+ spirv-headers,
+ spirv-tools (>= 2020.2),
 Standards-Version: 4.5.0
 Section: libs
 Homepage: https://github.com/KhronosGroup/Vulkan-ValidationLayers
